<template>
  <v-dialog
      v-model="dialog"
      width="500"
    >
    <template v-slot:activator="{ on, attrs }">
      <v-btn
        color="red lighten-2"
        dark
        v-bind="attrs"
        v-on="on"
      >
        Add proposal
      </v-btn>
    </template>

    <v-card
      class="mx-auto my-12"
      max-width="400"
      >
      <v-card-title>Propose</v-card-title>
      <v-card-text>
        <v-row>
          <v-col
            cols="12"
          >
          <v-text-field
            label="Title"
            v-model="proposal.title"
          ></v-text-field>
         </v-col>
        </v-row>

        <v-row>
          <v-col>
            <actions v-model="proposal.actions" />
          </v-col>
        </v-row>

        <v-row
          align="center"
          justify="space-around"
        >
          <v-btn @click="submit" color="primary">
          Submit
          </v-btn>
        </v-row>
      </v-card-text>
    </v-card>
  </v-dialog>
</template>

<script>
  import Actions from "./action/List";
  import GovernorVotes from "@openzeppelin/contracts/build/contracts/GovernorVotes.json";
  import { ethers } from "ethers";

  export default {
    name: "Proposal",
    data: () => ({
      proposal: {
        title: null,
        actions: [{}]
      }
    }),
    components: {
      Actions
    },
    methods: {
      async submit() {
        const provider = this.$store.state.provider;
        const addresses = this.proposal.actions.map(action => action.contract);

        const callDatas = [];
        const values = [];

        this.proposal.actions.forEach(action => {
          const votingContract = new ethers.Contract(
            action.contract,
            action.abi,
            provider);

          const paramValues = action.methodParams.map(p => p.value);

          callDatas.push(
            votingContract.interface.encodeFunctionData(
              action.methodName,
              paramValues
            )
          );

          values.push(action.value ? action.value : "0");
        });

        const governor = new ethers.Contract(
          this.$store.state.governor.address,
          GovernorVotes.abi,
          provider);

        await governor.connect(provider.getSigner(this.$store.state.accounts[0])).propose(addresses, values, callDatas, this.proposal.title);
      }
    }
  }
</script>
